--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"
local CountFont = "Interface\\Addons\\Inked\\Fonts\\SF Comic Script.ttf"
local CountFontSize = 13
local CountFontOutline = "OUTLINE"
local NameFont = "Interface\\Addons\\Inked\\Fonts\\Roboto.ttf"
local NameFontSize = 9
local NameFontOutline = "THINOUTLINE"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverAB10 = CreateFrame("Frame","AB10Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	MoverAB10:SetSize((ButtonSize * 12)+12, ButtonSize)
	--MoverAB10:SetPoint("CENTER", UIParent,"BOTTOM",220.5, 65.5)
	MoverAB10:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB10:SetClampedToScreen(true)
	MoverAB10:SetClampRectInsets(0, 0, 0,0)
local MoverAB10Text  = MoverAB10:CreateFontString(nil, "OVERLAY")
	MoverAB10Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB10Text:SetPoint("CENTER",MoverAB10,"CENTER", 0,0); 
	MoverAB10Text:SetText("")
	
	local function CreateButtonTexture(frame)
	local ButtonForeground = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForeground:SetAllPoints(frame)
		  ButtonForeground:SetFrameLevel(4)
		  ButtonForeground:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButton",
			edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\InkedBorder",
			edgeSize = 16,
			insets = {top = 4, left = 4, bottom = 4, right = 4}})
		ButtonForeground:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		ButtonForeground:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
end

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.AB10Enable == true then
			local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB10:GetPoint(n)
				Inked.db.profile.MoverAB10X = xOfs
				Inked.db.profile.MoverAB10Y = yOfs
				Inked.db.profile.MoverAB10Point = point
				--Inked.db.profile.MoverAB10RelPoint = relativePoint
				--print(point.." "..relativePoint)
				MoverAB10Text:SetText("Inked Bar 10")
		end		
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
	
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end



local function MakeBar10()
	if Inked.db.profile.UseActionBars == false then return end
	if UnitClass("player") == "Druid" then return end
	local InkedBar10 = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedBar10:SetAllPoints(MoverAB10)

	ButtonSize = Inked.db.profile.AB10ButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		InkedBar10config = {
				outOfRangeColoring = "button",
				tooltip = "enabled",
				showGrid = true,
				colors = {
					range = { 0.8, 0.1, 0.1 },
					mana = { 0.5, 0.5, 1.0 }
				},
				hideElements = {
					macro = false,
					hotkey = false,
					equipped = false,
				},
				keyBoundTarget = false,
				clickOnDown = false,
				flyoutDirection = "UP",	
			}
		CreateFrame("Frame", "InkedActionBar10", UIParent, "SecureHandlerStateTemplate")
		InkedActionBar10:SetParent(InkedBar10)
		InkedActionBar10:SetPoint("RIGHT", InkedBar10,"LEFT",ButtonSize/2,0)
		RegisterStateDriver(InkedActionBar10, "vehicle", "[petbattle][overridebar] hide;show")	
		InkedActionBar10:SetAttribute("_onstate-vehicle", [[
			if newstate == "hide" then
			  self:Hide();
			else
			  self:Show();
			end
		]]) 
		--local ButtonSize = Inked.db.profile.ButtonSize
		--local lastnumber = 109 + Inked.db.profile.Bar7ButtonNumber
		local lastnumber = 109 + 12

			

	if Inked.db.profile.AB10Enable == true then
		InkedBar10:Show()
		if Inked.db.profile.Bar10BarLayout == 1 then
					for i = 109,lastnumber-1 do -- bar 1
						local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
						Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*(ButtonSize+MySpacing*1.5),0)
						Inkedbutton10:Show()
						Inkedbutton10:SetState(0, "action", i)
						Inkedbutton10:SetSize(ButtonSize,ButtonSize)
						Inkedbutton10:SetAttribute("buttonlock",true)
						Inkedbutton10:SetAttribute("checkselfcast",true)
						Inkedbutton10:SetAttribute("checkfocuscast",true)
						Inkedbutton10:UpdateConfig(InkedBar10config)
					end
				--	InkedActionBar10:SetPoint("LEFT", InkedBar10,0,0)
				elseif Inked.db.profile.Bar10BarLayout == 2 then
					MoverAB10:SetSize(ButtonSize*6, ButtonSize* 2)
					InkedActionBar10:SetPoint("LEFT", InkedBar10,4,20)
					if lastnumber > 114 then
						for i = 109,114 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*ButtonSize,0)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end
						for i = 115,lastnumber-1 do -- bar 1
							local Inkedbutton10a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10a:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-115)*ButtonSize,-(ButtonSize+1))
							Inkedbutton10a:Show()
							Inkedbutton10a:SetState(0, "action", i)
							Inkedbutton10a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10a:SetAttribute("buttonlock",true)
							Inkedbutton10a:SetAttribute("checkselfcast",true)
							Inkedbutton10a:SetAttribute("checkfocuscast",true)
							Inkedbutton10a:UpdateConfig(InkedBar10config)
						end
					else
						for i = 109,lastnumber-1 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*ButtonSize,0)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end					
					end
							
				elseif Inked.db.profile.Bar10BarLayout == 3 then
					MoverAB10:SetSize(ButtonSize*4, ButtonSize* 3)
					InkedActionBar10:SetPoint("LEFT", InkedBar10,8,33)
					if lastnumber > 112 then
						for i = 109,112 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*ButtonSize,0)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end
						for i = 113,116 do -- bar 1
							local Inkedbutton10a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10a:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-113)*ButtonSize,-(ButtonSize+1))
							Inkedbutton10a:Show()
							Inkedbutton10a:SetState(0, "action", i)
							Inkedbutton10a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10a:SetAttribute("buttonlock",true)
							Inkedbutton10a:SetAttribute("checkselfcast",true)
							Inkedbutton10a:SetAttribute("checkfocuscast",true)
							Inkedbutton10a:UpdateConfig(InkedBar10config)
						end
						for i = 117,lastnumber-1 do -- bar 1
							local Inkedbutton10b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10b:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-117)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton10b:Show()
							Inkedbutton10b:SetState(0, "action", i)
							Inkedbutton10b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10b:SetAttribute("buttonlock",true)
							Inkedbutton10b:SetAttribute("checkselfcast",true)
							Inkedbutton10b:SetAttribute("checkfocuscast",true)
							Inkedbutton10b:UpdateConfig(InkedBar10config)
						end
					else
						for i = 109,lastnumber-1 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*ButtonSize,0)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end					
					end
				
				elseif Inked.db.profile.Bar10BarLayout == 4 then
					InkedActionBar10:SetPoint("TOPLEFT", InkedBar10,"BOTTOMRIGHT",-15,15)
					MoverAB10:SetSize(ButtonSize, ButtonSize* 12)
					for i = 109,lastnumber-1 do -- bar 1
						local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
						Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",0,(i-109)*ButtonSize)
						Inkedbutton10:Show()
						Inkedbutton10:SetState(0, "action", i)
						Inkedbutton10:SetSize(ButtonSize,ButtonSize)
						Inkedbutton10:SetAttribute("buttonlock",true)
						Inkedbutton10:SetAttribute("checkselfcast",true)
						Inkedbutton10:SetAttribute("checkfocuscast",true)
						Inkedbutton10:UpdateConfig(InkedBar10config)
					end
				elseif Inked.db.profile.Bar10BarLayout == 5 then
					MoverAB10:SetSize(ButtonSize*2, ButtonSize* 6)
					InkedActionBar10:SetPoint("TOPLEFT", InkedBar10,"BOTTOMRIGHT",10,15)
					if lastnumber > 114 then
						for i = 109,114 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",0,(i-109)*ButtonSize)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end
						for i = 115,lastnumber-1 do -- bar 1
							local Inkedbutton10a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10a:SetPoint("CENTER", InkedActionBar10,"CENTER",-ButtonSize,(i-115)*ButtonSize)
							Inkedbutton10a:Show()
							Inkedbutton10a:SetState(0, "action", i)
							Inkedbutton10a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10a:SetAttribute("buttonlock",true)
							Inkedbutton10a:SetAttribute("checkselfcast",true)
							Inkedbutton10a:SetAttribute("checkfocuscast",true)
							Inkedbutton10a:UpdateConfig(InkedBar10config)
						end
					else
						for i = 109,lastnumber-1 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*ButtonSize,0)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end					
					end
				
				elseif Inked.db.profile.Bar10BarLayout == 6 then
					MoverAB10:SetSize(ButtonSize*3, ButtonSize*4)
					InkedActionBar10:SetPoint("LEFT", InkedBar10,10,52)
					if lastnumber > 111 then
						for i = 109,111 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*ButtonSize,0)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end
						for i = 112,114 do -- bar 1
							local Inkedbutton10a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10a:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-112)*ButtonSize,-(ButtonSize+1))
							Inkedbutton10a:Show()
							Inkedbutton10a:SetState(0, "action", i)
							Inkedbutton10a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10a:SetAttribute("buttonlock",true)
							Inkedbutton10a:SetAttribute("checkselfcast",true)
							Inkedbutton10a:SetAttribute("checkfocuscast",true)
							Inkedbutton10a:UpdateConfig(InkedBar10config)
						end
						for i = 115,117 do -- bar 1
							local Inkedbutton10b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10b:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-115)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton10b:Show()
							Inkedbutton10b:SetState(0, "action", i)
							Inkedbutton10b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10b:SetAttribute("buttonlock",true)
							Inkedbutton10b:SetAttribute("checkselfcast",true)
							Inkedbutton10b:SetAttribute("checkfocuscast",true)
							Inkedbutton10b:UpdateConfig(InkedBar10config)
						end
						for i = 118,lastnumber-1 do -- bar 1
							local Inkedbutton10c = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10c:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-118)*ButtonSize,-(ButtonSize+1)*3)
							Inkedbutton10c:Show()
							Inkedbutton10c:SetState(0, "action", i)
							Inkedbutton10c:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10c:SetAttribute("buttonlock",true)
							Inkedbutton10c:SetAttribute("checkselfcast",true)
							Inkedbutton10c:SetAttribute("checkfocuscast",true)
							Inkedbutton10c:UpdateConfig(InkedBar10config)
						end
					else
						for i = 109,lastnumber-1 do -- bar 1
							local Inkedbutton10 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar10)
							Inkedbutton10:SetPoint("CENTER", InkedActionBar10,"CENTER",(i-109)*ButtonSize,0)
							Inkedbutton10:Show()
							Inkedbutton10:SetState(0, "action", i)
							Inkedbutton10:SetSize(ButtonSize,ButtonSize)
							Inkedbutton10:SetAttribute("buttonlock",true)
							Inkedbutton10:SetAttribute("checkselfcast",true)
							Inkedbutton10:SetAttribute("checkfocuscast",true)
							Inkedbutton10:UpdateConfig(InkedBar10config)
						end					
					end
				
				end -- end folds
					for i = 109,120 do -- bar 6
							local normalBar10 = _G["InkedbuttonBar"..i]							
						--	CreateButtonTexture(normalBar10)
							normalBar10.NormalTexture:Hide()
							local Highlight = normalBar10:GetHighlightTexture()						
							local Pushed = normalBar10:GetPushedTexture()
							Highlight:SetTexture(HightlightTex)
							Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
							Pushed:SetTexture(PushedTex)							
							local count = _G[normalBar10:GetName()..'Count']
							count:SetFont(CountFont,CountFontSize,CountFontOutline)
							local name = _G[normalBar10:GetName()..'Name']
							name:SetWidth(55)
							name:SetFont(NameFont,NameFontSize,NameFontOutline)
							normalBar10:CreateBeautyBorder(BorderSize)
							normalBar10:SetBeautyBorderPadding(BorderPadding)
							normalBar10:SetBeautyBorderTexture("white")
							--normalBar10:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							if Inked.db.profile.ClassABColor == true then
								normalBar10:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							elseif Inked.db.profile.ClassABColor == false then
								if Inked.db.profile.CustomABColor == true then
									normalBar10:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
								elseif Inked.db.profile.CustomABColor == false then
									normalBar10:SetBeautyBorderColor(1,1,1,1)
								end
							end
		
						end
		end
		if(Inked.db.profile.lockframes == false) then
			MoverAB10:ClearAllPoints()
			if Inked.db.profile.MoverAB10Point == nil then
				MoverAB10:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB10X,Inked.db.profile.MoverAB10Y)
			else
				MoverAB10:SetPoint(Inked.db.profile.MoverAB10Point, UIParent,Inked.db.profile.MoverAB10X,Inked.db.profile.MoverAB10Y)
			end
			if Inked.db.profile.AB10Enable == true then
				CreateMoverBackdrop(MoverAB10)
				MoverAB10:SetMovable(true)
				MoverAB10:EnableMouse(true)
				MoverAB10:RegisterForDrag("LeftButton")
				MoverAB10:SetScript("OnDragStart", MoverAB10.StartMoving)
				MoverAB10:SetScript("OnDragStop", MoverAB10.StopMovingOrSizing)
				MoverAB10:SetUserPlaced(true)
			end
			elseif Inked.db.profile.MoverAB10Point == nil then
				MoverAB10:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB10X,Inked.db.profile.MoverAB10Y)
			else
				MoverAB10:SetPoint(Inked.db.profile.MoverAB10Point, UIParent,Inked.db.profile.MoverAB10X,Inked.db.profile.MoverAB10Y)
		end
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBar10()									
		end)